package uhk.salay.npl.demonpl.jpa.model;

import java.util.Objects;
import javax.persistence.*;
import javax.persistence.Entity;

import lombok.Data;

@Data
@Entity
@Table(name = "Emotions")
public class Emotion {
  @OneToOne
  @JoinColumn(name = "entity_id", referencedColumnName = "id")
  public uhk.salay.npl.demonpl.jpa.model.Entity entity;
  @ManyToOne
  @JoinColumn(name = "file_id", referencedColumnName = "id")
  public File file;
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private int id;
  private String type;
  private Double value;


  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  @Basic
  @Column(name = "type")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  @Basic
  @Column(name = "value")
  public Double getValue() {
    return value;
  }

  public void setValue(Double value) {
    this.value = value;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Emotion emotions = (Emotion) o;
    return id == emotions.id &&
        Objects.equals(type, emotions.type) &&
        Objects.equals(value, emotions.value);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, type, value);
  }

  @Override
  public String toString() {
    return String.format("Emoce: %s hodnota: %s",type,value);
  }
}
