package uhk.salay.npl.demonpl.jpa.model;

import java.util.Objects;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import lombok.Data;

@Data
@Entity
@Table(name = "Parts")
public class Part {
  private short id;
  private String category;
  private String concept;
  private String keyword;
  private String text;
  private int fileId;
  private Double sentiment = 0.0;

  @Id
  @Column(name = "id")
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  public short getId() {
    return id;
  }

  public void setId(short id) {
    this.id = id;
  }

  @Basic
  @Column(name = "category")
  public String getCategory() {
    return category;
  }

  public void setCategory(String category) {
    this.category = category;
  }

  @Basic
  @Column(name = "concept")
  public String getConcept() {
    return concept;
  }

  @Basic
  @Column(name = "file_id")
  public int getFileId() {
    return fileId;
  }

  public void setFileId(int fileId) {
    this.fileId = fileId;
  }

  public void setConcept(String concept) {
    this.concept = concept;
  }

  @Transient
  public String getText() {
    return text;
  }

  public void setText(String text) {
    this.text = text;
  }

  @Basic
  @Column(name = "keyword")
  public String getKeyword() {
    return keyword;
  }

  public void setKeyword(String keyword) {
    this.keyword = keyword;
  }


  @Basic
  @Column(name = "sentiment")
  public Double getSentiment() {
    return sentiment;
  }

  public void setSentiment(Double sentiment) {
    this.sentiment = sentiment;
  }
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Part part = (Part) o;
    return id == part.id &&
        Objects.equals(category, part.category) &&
        Objects.equals(concept, part.concept);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, category, concept);
  }
}
