package uhk.salay.npl.demonpl;

import com.zaxxer.hikari.HikariDataSource;
import java.sql.SQLException;
import java.util.Optional;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import uhk.salay.npl.demonpl.jpa.model.Entity;
import uhk.salay.npl.demonpl.jpa.model.Relation;
import uhk.salay.npl.demonpl.jpa.model.Type;
import uhk.salay.npl.demonpl.jpa.repositorys.EntityRepository;
import uhk.salay.npl.demonpl.jpa.repositorys.RelationRepository;
import uhk.salay.npl.demonpl.jpa.repositorys.TypeRepository;
import uhk.salay.npl.demonpl.watson.WatsonService;

@RunWith(SpringRunner.class)
@SpringBootTest
public class DemonplApplicationTests {

  @Autowired
  protected TypeRepository typeRepository;
  @Autowired
  protected EntityRepository entityRepository;
  @Autowired
  protected RelationRepository relationsRepository;
  @Autowired
  protected HikariDataSource dataSource;
  @Autowired
  protected WatsonService watsonService;

  @Test
  public void name() {
    final Iterable<Relation> all = relationsRepository.findAll();
    for (Relation type : all) {
      System.out.println(type.getType());
    }
  }

  @Test
  public void insetTest() throws SQLException {
    final Optional<Type> byId = typeRepository.findById(1);
    Assert.assertEquals("Person", byId.get().getName());
    final Entity radek = entityRepository.findByName("Radek");
    Assert.assertEquals("Radek", radek.getName());
  }
}
